/*
	Write by xempo 2013
	Free under LGPL
*/

#ifndef	  High_Light
#define	High_Light

#include <qsyntaxhighlighter.h>
#include "txtstyle.h"
extern int *__params;
class Editor;

#define  CS_Modifying  -9
#define  CS_Init  -10

enum SC { SC_Norm=0, SC_BZ_cpp=1,  SC_BZ_c=2,  SC_YH=3 };

class HighLighter : protected QSyntaxHighlighter
{
public :
 HighLighter( Editor *textEdit, const StyleVal *c, const unsigned int *line_style);
 void init(){
	_init();
	rehighlight();
	}

 void setInputLine(int val){ inputLine=val; }

 void setFnt(const QFont &fnt1){ fnt=fnt1; }

 void setCStyle(const StyleVal *c, const unsigned int *line_style){
	colors=c;
	YHcolor=line_style[0];
	BZcolor=line_style[1];
	cppBZcolor=line_style[2];
 }

 int feelFormat(const char *, int para);

 inline void restore(){
		styleCount=__params[54] ? StyleCount : StyleCount-3;
	}
 void _init();

protected :
 virtual int highlightParagraph( const QString &text, int endStateOfLastPara );

private:
 const unsigned int  orgColor;
 QFont fnt;
 void setStyle(int s, int len, unsigned int c, bool bold, bool italic, bool UL);

 int paraBack, styleCount, orgline,
	inputLine; // >0特殊，-9 常态input

 Editor *edt;
 const TxtStyle *c_style;
 unsigned int YHcolor, BZcolor, cppBZcolor;
 const StyleVal *colors;
 bool MemChr(const char *src,const  char chr, const int len);

//--------------backup status---------

};

#endif
