/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of this file
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void scopy(char *d, const char *s)
{  while( (*d++=*s++) ); }

char *catstr(const char *dat, const char *extdat)
{
int len=strlen(dat);
char *pRt=(char *)malloc(len+strlen(extdat)+4);
scopy(pRt,dat);
scopy(pRt+len,extdat);
return pRt;
}

const char nOpen[]="Can't open file: %s !\n";
char *_ProgPath;
FILE *PathOpen(const char *fnm, const char *fmode)
{
FILE *fp;
const char *pt=fnm;
start:fp=fopen(pt,fmode);
if(fp==NULL){
	if(pt==fnm&&_ProgPath){
		pt=catstr(_ProgPath,fnm);
		goto start;
		}
	else if(pt!=fnm)free((void *)pt);
	}
return fp;
}

unsigned  FmtText(char *buf,unsigned  len)
{
  register unsigned  i;
  for(i=0;i<len;i++)if(buf[i]=='\r'){
	if(buf[i+1]=='\n'){
		int j;
		for(j=i; j<len; j++)buf[j]=buf[j+1];
		len--;
	}
	else buf[i]='\n';
  }
  return len;
}


char *ReadFile(const char *fname,unsigned int *filelen)
{
unsigned int len;
char *buf;
FILE *fp=PathOpen(fname,"rb");
if(fp==NULL){ printf(nOpen,fname); return NULL; }
 else {/* open ok */
  fseek(fp,0,2);  len=ftell(fp);

#ifndef _LINUX_SOURCE
  if(len>0xfffe ){
	printf("FileSize>=64k,\nabort to proccess %s!\n",fname);
	goto skp;
	}
#endif

  buf=(char *)malloc(len+4);
  if(buf==NULL){
	puts("Fail to alloc memory !");
	skp:fclose(fp);	return NULL;
	}
  rewind(fp);
  len=fread(buf,1,len,fp);
  fclose(fp);	buf[len]=0;
  *filelen=FmtText(buf,len);
return buf;
	}
}

