/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2010, 2014
	Free under LGPL
*/

#include "normal.h"
#include "numbtype.h"
#include "fspdir.h"
#include "fspio.h"
#include "write.h"
#include "read.h"
#include "jxswitch.h"
#include "shellcom.h"
#include "stdfun.h"

#ifdef	_Simple_Base_
#include "simplebase.h"
#endif

#include "dialogid.h"
#include "infor.h"
#include "input.h"
#include "script.h"
#include "options.h"


#ifdef  _LINUX_SOURCE
#define  DiGueiLmt  80
#else 
#define  DiGueiLmt  35 // for DOS
#endif

int scpline, diguei, isRS;
char *scpbuf, *scpfname, memSepara[2];

const char DPdef[]="Permission denied", divsyb[]={10,32,9,0 }, separaChs[]=" \t",
quitScp[]="Press \'q\' to quit this running, press \'e\' to end this script, other continue";

#define	isSyb(txt)		((txt[-1]!='\"' || txt[1]!='\"') && (txt[-1]!='\'' || txt[1]!='\''))

char *NumbBlack(char *dat,MAU *send, unsigned int len, int style)
{/* free write first line after '{', end of data before '}' */
if(dat){
  int symb=0;
  char *bufhd=dat, *bufend, *pt;
  BOOL remflg=False, contin;
  while(*bufhd!='{'||isSyb(bufhd)==False){
	if(*bufhd=='/'&&bufhd[1]=='/'){ remflg=True; bufhd+=2; }
	if(remflg==False&&strchr(divsyb,*bufhd)==NULL){
		pt=strchr(bufhd, '\n');
		if(pt){ 
			unsigned int L=pt-bufhd; memcpy(OutBuf, bufhd, L); OutBuf[L]=0;
			scpbuf=OutBuf;
			}
		else scpbuf=bufhd;
		fspHB(33,True);
		return dat; /* error sig */
	}
	if(*bufhd==10){
		scpline++; 
		if(remflg)remflg=False;
	}
	bufhd++;
  }
  bufhd++;
  while( strchr(divsyb, *bufhd ) )
	if(*bufhd++=='\n'){
		scpline++;
		if(style==_void||style==_txt)break;
	}

   for(bufend=bufhd; (unsigned int)(bufend-dat)<len; bufend++)
	switch(*bufend){
	case 10 : scpline++; break;
/*	case 2 : *bufend='{'; break;	case 3 : *bufend='}'; break;*/
	case '{' : if(isSyb(bufend))symb++;
		break;
	case '}' :	if(isSyb(bufend) && symb--==0){
	_end_:	*bufend=0;/* for prnerr */
		pt=bufend-1;
		for(contin=True; contin&&pt>=bufhd&&strchr(divsyb,*pt);pt--) /*{10,32,9,0}*/
			if(*pt==10 && (style==_void||style==_txt) )contin=False;

		send->buf=bufhd; send->len=pt+1-bufhd;
		return bufend+1;
		}
	}
   if(symb==0)goto _end_;
}
fspHB(34,True);
return NULL;
}

void dataLens(const char *pt, int *Lens)
{
const char *ptr;
while(*pt==32||*pt==9)pt++;
ptr=pt;
_loop_: if(*pt==','||*pt==0){
	*Lens++=atol(ptr);
	if(*pt){
		ptr=pt++;
		goto _loop_;
		}
	}
}

fsp_lib *fspScript(fsp_lib *lib, char *pm, int msg, const char *inpPath)
{/* lib-program scriptor, read text file & tell fsp_lib how to autowork */
if(diguei<DiGueiLmt){/* limit for wrong script or safe */
  int dau, oldline, cntline=1, step, n, j, appendMsg=0, wr=-1,
 	numb, rdmsg=0;
  unsigned int Len, i, len;
  BOOL RemMsg, nxRemMsg=False, echomsg=False, goTag=True;
  char *ptline, *buf0, *buf2, *ptr,
	chr, *oldscp, *pidx, *buff, *fnam, *Pt, *pthbuf=NULL;
  diguei++;    fnam=pm;
  if( (isRS=(msg&1)) ){
     if(inpPath&&*fnam!='/')fnam=catstr(inpPath, fnam, '/');
     buff=ReadFile(fnam, &Len,True, fspX, &fspPaths);
  }
  else { buff=fnam; Len=strlen(buff); }

  if(lib && (msg&2) ){
	rdmsg=lastNumb(lib->CurDir);
	appendMsg=append_Mode;
	}
  buf0=buff;     buf2=buff+Len;

  while(buff && goTag && CommNumb<FSP_quit/* 4096 */ ){
/* !=Quit_Script_Run  && !=End_Script_Run && !=FSP_exit(11520) &&!=FSP_quit */
/* FSP_quit(4096)quit abort prg result,  FSP_exit(11520)exit norml-exit */
    CommNumb=-20; step=0;
    if((ptline=strchrs(buff,"\n;"))!=NULL){
	if((chr=*ptline)=='\n')step=1;
	*ptline++=0;
    }
    else goTag=False;
    RemMsg=ignoreStr(buff,&nxRemMsg,chr);
    if(echomsg)msgShow(buff);
    if(RemMsg==False){
      ptr=strdup(buff);
      scpline=cntline; scpbuf=buff;  scpfname=fnam;
      lib=comRun(lib, ptr, appendMsg, inpPath);
      free(ptr);
      switch(CommNumb){
      case FSP_FreeStarPlus :
	pthbuf=fullname(fnam);
	Pt=(char *)separChr(pthbuf);
	if(Pt)*Pt=0;
	inpPath=(const char *)pthbuf;
	break;
      case FSP_pause : msgShow(quitScp);
	idxdscpt=0x7fff;	/* safe */
	char qbu[8];
	if(getMsg)switch(popMsg(NULL,NULL, 3, fspX)){
		case 0 :  CommNumb=Quit_Script_Run; /* quit all script */
			break;
		case 1 : CommNumb=End_Script_Run; /* abort this script */
		}
	else switch(inCon(qbu,4)){
		case 'q' : CommNumb=Quit_Script_Run; /* quit all script */
		break;
		case 'e' :  CommNumb=End_Script_Run; /* end this script */
		}
	break;
      case FSP_echo : for(ptr=buff; *ptr==32||*ptr==9; ptr++);
		if((ptr=strchrs(ptr, separaChs))!=NULL){
			while(*ptr==9||*ptr==32)ptr++;
			msgShow(ptr);
		}
		break;
      case echo_on : echomsg=True; break;
      case echo_off : echomsg=False; break;

#ifdef		_Simple_Base_
      case FSP_mkbase : {/* make struct */
		MAU mau;
		ptr=ptline;
		ptline=NumbBlack(ptline, &mau, strlen(ptline),_sold);
		cntline=scpline;
		if(ptline&&ptline!=ptr){
		  mau.buf[mau.len]=0;
		  if(!CreatField(lib,lib->CurDir, mau.buf))goto sqdef;
		}
		else sqdef: msgShow(DPdef);
		break;
		}
#endif
      case FSP_sysnumbset :
      case FSP_numbset : { /* numbset, begin UXB  */
	MAU *send;
	char **pms, **argv;
	int *aLn, *Ln, argc, M, T, tPos=FCU_TypePos(lib->CurDir->Format);
	BYTE *fcu, *type;
	idxdscpt=0x7fff;
	oldscp=scpbuf; oldline=cntline;
	dau=lib->CurDir->DAUC;
#define  mu2  5
	static const char *nmbattr[mu2]={"-l", "-m", "-t", "-u", "-a" }, *_nmbattr[mu2]={"--len","--mode","--type","--unita", "--alen" };
	int val[mu2];
	memset(val, 0, sizeof(int)*mu2);
	ProcOpt opt={mu2,nmbattr, _nmbattr,	val,0,NULL};
	argc=0x7fff;
	argv=setargv(buff, separaChs, &argc);
	pms=argv+1;	
	arglists *alst=procParas(argc-1, pms, NULL, &opt);
	if(alst){
		if(alst->argc){
			if(isNumb(alst->argv[0])==False){
				wr=popMsg(alst->argv[0], NULL, NumbsetErrorId, fspX)+5;
				goto _exitloop_;
			}
			numb=atol(alst->argv[0])+rdmsg;
			unPara(alst, 1);
			}
		else {
			fspHB(I_None_60, True);
			showUsage(FSP_numbset);
			goto _out_;
		}
	}
	else break;
	char **subargv=alst->subarg->argv;
	if(val[3] && (n=atoi(subargv[3]))<dau)dau=n;
	fcu=(unsigned char *)zalloc(dau*(2*sizeof(char)+2*sizeof(int)) + tPos );
	aLn=(int *)(fcu + tPos + dau);
	Ln=aLn+dau;
	type=(BYTE *)(Ln+dau);	memset(type,_sold,dau);/* use func less size than var init */
	fcu[1]=FSP_MR|FSP_MW;
	for(i=0; i<mu2-1; i++)
	   if(val[i])switch(i){
		case 0 :
		case 4 : dataLens(subargv[i], i ? aLn : Ln);
			break;
		case 1 : M=cvtPara(subargv[1], "rwho-");
			if(M<0)fspHB(43,True);
			else fcu[1]=M;
			break;
		case 2 :/* if val=null, default=_sold look init... */
		    pidx=subargv[2];
		    for(n=0,T=0,j=0;n<dau&&strchr(divsyb,pidx[n])==NULL;n++){
			if(T!=_separa)/* follow _separa, the char must skip */
			     T=fixType(type,j++,dau,pidx[n],pidx[n+1]);
//			if(CommNumb==Quit_Script_Run||CommNumb==End_Script_Run)goto _exitloop_;
			}
		}
	len=ptline-buf0;
	if(len>=Len)goto _exitloop_;
	len=Len-len;
	send=MAUalloc(dau);
	for(j=0; j<dau; fcu[tPos+j++]=T )if((T=type[j])!=_none){
	  ptr=ptline;	  scpline=cntline;
	  ptline=NumbBlack(ptr,send+j, Ln[j]>0&&Ln[j]<len ? Ln[j] : len, T);
	  send[j].alen=aLn[j];
	  cntline=scpline;
	  if(ptline==NULL||ptline==ptr){
		free(send); free(fcu);
		CommNumb=Quit_Script_Run;
		goto _exitloop_;
		}
	  if(T!=_void){
/*	    ptr=send[j].buf; ptr[send[j].len]=0;*/
		if(T==_separa)*memSepara=type[j+dau];
		T=putMAU(send+j,send[j].buf,T);
	  }
	}
	if(lib){
	   if(idxdscpt>0x7ffd){
		scpline=oldline;/* perhan writeNFCU occu error, so scpline(err-msg) must reset */
		scpbuf=oldscp;
		fmtFCU fmt={ fcu, numb, 0, 0 };
		lib->sys_Id_done=(CommNumb==FSP_sysnumbset);
		if(writeNFCU(lib->CurDir, &fmt, send, dau)==False)wr=OverWrite;
		lib->sys_Id_done=False;
	   }
	   else reportBug();
	}
	for(j=0;j<dau;j++){
	     if((T=fcu[tPos+j])==_file||IsIntType(T))free(send[j].buf);
	}
	free(send); free(fcu);
	_out_: argsFree(alst); free(argv);
	} // FSP_numbset
      }
      }
      buff=ptline;      cntline+=step;
/*if(buff==NULL)msgShow("  Success");if(buff-buf0>=Len)msgShow("  end");*/
  }
  _exitloop_: diguei--;
  isRS=msg&1;
  if(buf0 && isRS )free(buf0);
  if(pthbuf)free(pthbuf);
  if(fnam!=pm)free(fnam);

  if(CommNumb==End_Script_Run)CommNumb=-20; /* only end this script */
  else if(CommNumb<FSP_quit){
	if(wr!=-1)CommNumb=wr;  // pe write
	else CommNumb=-20;/* disable -10 */
	}
  }
  return lib;
}
