/*
	Write by LinJuangHua(xempo) 12-2013
	xempo 保留此文件的原有版权
	Free under LGPL
*/

#ifndef	_EDITOR_
#define	_EDITOR_

#include <qtextedit.h>
#include <stdlib.h>
#include "highlight.h"

class ProEdit;

#define  isYH(ptxt, i)  (ptxt[i]=='\"'&& (i<1||ptxt[i-1]!='\\'|| i>1&&ptxt[i-2]=='\\'))

extern const char div_syb[];

class Editor : public QTextEdit
{
public :
Editor(QWidget *);
~Editor();
void keysFunc(int k, int st);

void recorTextPos(int p){
	curP=p;
	curS=text(p);
	if(smP==-1)smP=p;
	}

HighLighter *getHL(){ return highlighter; }

void setHL(HighLighter *hl){ highlighter=hl; }

bool cs_feel() const
{ return CS_feel; }

bool yh_feel() const
{ return YH_feel; }

bool sel_feel() const
{ return Sel_feel; }

int paste_feel() const
{ return Paste_feel; }

bool undo_feel() const
{ return Undo_feel; }

void setPasteFeel(int val){Paste_feel=val;}

void curFeel(const char *txt, int idx);

void styleFeel();

bool testMdf(int p){ return (saveP==p && saveS==text(p) || text(p)==smS&&smP==p ); }

void setSavePos(){	saveP=curP; saveS=curS; smP=-1; }

bool saveMsg(){ return saveP!=-1; }

void setPosRc(int p) { if(smP==-1)smS=text(p); }

bool todoMsg, update;

public : // slots :
virtual void paste();

protected:
bool event( QEvent *);
void  virtual  undo();
void  virtual  redo();
void  virtual  cut();

private:
QString curS, saveS, smS;
int curP, saveP, smP; // save & move

bool CS_feel, YH_feel,
	Sel_feel, Undo_feel;

HighLighter *highlighter;

int Paste_feel; // 1 paste for firstline; 2 paste next line; 0 none

ProEdit *proedit;

const char *unitSepa;

// void highlightPaste(const char *ptxt);

// --------------------------------------
int cn_syb, zhu, sybCount;
bool sybForward(const char *ptxt, int p, int i);
bool sybBackward(const char *ptxt, int p, int i);
bool sybJmp(const char *ptxt, int p, int i);
};

#endif

