/*
	Write by LinJiangHua(xempo) 2012-2013
	Copyright LinJiangHua 2012-2013
*/

#include "txtstyle.h"

const char *ctype0[11]={ "define","undef","if","else","endif","elif", "ifdef", "ifndef", "pragma", "error", "line" },
	*ctype1="include",
	*ctype2[13]={ "char","long","void","short","unsigned","signed","float","double","bool","struct","union","class","int" },
	*ctype3="return",  *ctype4="else", *ctype5="default", *ctype6="case",
	*ctype7[3]={ "break", "continue" ,"goto" }, *ctype8[5]={	"while","if","for","switch","catch" },
	*ctype9[3]={"extern","static","friend"}, *ctype10[2]={ "true","false" },  *ctype11[2]={"const","__const" },
	*ctype12="new", *ctype13="delete", *ctype14[2]={"try","do"},*ctype15="sizeof",*ctype16="this",
	*ctype17[4]={"public","protected","private","slots"}, *ctype18[2]={"inline","enum"},
	*ctype19="typedef",	*ctype20[6]={"newspace", "namespace", "asm","pascal","throw","template" },
	*ctype21[9]={"virtual","volatile","near","far","huge","interrupt","cdecl","_cdecl","__cdecl"},
	*ctype22="operator",  *ctype23[2]={"auto","register"},
	*Tfsp0[7]={ "mkfsp", "mkdir", "numbset", "impcreat", "import", "setdscpt", "exe" },
	*Tfsp1[11]={ "close", "del", "rm", "erase", "rmdir", "export", "exit", "quit", "end", "abort", "rmdscpt" },
	*Tfsp2[4]={"insert", "write", "select", "read" };

const StyleVal fervorLad[StyleCount]={
{ qRgb(2, 85, 9 ), true, false, false },
{ qRgb(0x3c, 0x26, 0x71),  true, false, true },
{ qRgb(40, 78, 255), true, false, false },
{ qRgb(142, 0, 0), true, false, false },
{ qRgb(9, 9, 0xa0), true, false, false},
{ qRgb(9, 9, 0xa0),true, false, false },
{ qRgb(9, 9, 0xa0), true, false, false}, // 6
{ qRgb( 142,0,0 ),true, false, false} ,
{ qRgb( 9, 9, 0xa0 ), true, false, false}, 
{ qRgb(19, 58, 19), true, false, false}, 
{ qRgb(0xb0, 0x70, 0x35),false, false, false},
{ qRgb( 108, 58, 15),true, false, false},
{ qRgb(0x40, 0x80, 0x10),  true, false, false},// 12
{ qRgb(65, 20, 8), true, false, false },
{ qRgb( 9, 9, 0xa0 ),true, false, false },
{ qRgb(0xEA, 0x23, 0xa ), true, false, false } ,
{ qRgb(0x10, 0x12, 0x60),true, false, false},
{ qRgb( 77, 0, 9), true, false, false } ,
{ qRgb(0x72, 0xab, 0x27), true, false, false },  // enum
{ qRgb(0, 102, 102 ),true, false, false},
{ qRgb(0, 150, 150),true, false, false},
{ qRgb( 0, 59, 79 ),true, false, false},
{ qRgb(0, 200, 200), true, false, false}, 
{ qRgb(8, 0xa0, 20), true, false, false },
{ qRgb(0x10, 0x50, 0x10),  true, false, false },
{ qRgb(0x4c, 0x36, 0x78),  true, false, false },
{ qRgb(0x3c, 0x26, 0x77),  true, false, true },
};

const StyleVal WRAM[StyleCount]={
{ qRgb(0, 102, 102 ), true, false, true },
{ qRgb(0x3c, 0x26, 0x71), true, false, false},
{ qRgb(0x15, 0x12, 0xa0),true, false, false },
{ qRgb(40, 78, 255), true, false, false},
{ qRgb(0x5a, 0x97, 0x4e)  , true, false, false} ,
{ qRgb(0x5a, 0x97, 0x4e), true, false, false },
{ qRgb(0x5a, 0x97, 0x4e)  , true, false, false}, // 6
{ qRgb(40, 78, 255), true, false, false},
{ qRgb( 0x5a, 0x97, 0x4e ), true, false, false},
{ qRgb(90, 24, 26), true, false, false}, 
{ qRgb(0, 158, 180), true, false, false },
{ qRgb( 5, 0x80, 25 ), true, false, false},
{ qRgb(0x30, 0x70, 0x8), true, false, false},  // 12
{ 0x884040, true, false, false },
{ qRgb( 9, 9, 0xa0 ), true, false, false },
{ qRgb(0, 58, 89), true, false, false },
{ qRgb(2, 90, 40), true, false, false},
{ qRgb(87, 10, 10), true, false, false } ,
{ qRgb(0, 72, 72), true, false, true },  // enum
{ qRgb(0, 50, 68 ), true, false, true},
{ qRgb(4, 0xb0, 20), true, false, false},
{ qRgb(108, 58, 18), true, false, false},
{ qRgb(40, 0x28, 0x9a), true, false, false},
{ qRgb(220, 20, 10), true, false, false },
{ qRgb(0x90, 0x10, 0x10),  true, false, false },
{ qRgb(0x10, 0x10, 0x90),  true, false, false },
{ qRgb(40, 77, 220), true, false, true }
};

const StyleVal *_colors[cs_modul_cnt]={ fervorLad, WRAM };

const unsigned int lineStyle[2][3]={
	{ 0x884040, 0x838398, 0x55974e },
	{ 0xe0310a, 0x838398, 0x808090 },
};

const TxtStyle freeStyles[StyleCount]={
{"duiepl",  "# \t", " \t", 6,3,2,11 },
{"i",  "# \t",  " \"<\t", 1, 3, 4, 1 },
{"clvsufdbi"," ;,:({}<\t", " ,*()}\t", 9, 9, 7, 13 },
{ "r",  " \t;{}):", "; \t)(", 1, 7, 5,  1 },
{"e",  " \t};", " \t{", 1, 4,3, 1 },
{"d",  " \t;}", " \t:", 1, 4,3, 1 },
{"c",  " \t;{}", " \'\t" , 1, 5,3, 1 },
{"bcg", " :\t{});/", " \t;", 3, 8, 3, 3 },
{"wifsc",  " \t:;{})", "( \t", 5,7,3, 5 },  // 8
{"esf", " ;,:({<\t", " \t", 3,8, 2, 3 },
{"tf",  "/= \t?{(,:&|!;",  "/,;)}&| \t:", 2,13, 10,2 },
{"_c",  " ;,:({<\t", "; \t", 2, 8, 3,2 },
{"n",  " \t:(){},;=", " \t", 1,10, 2,1 }, // 12
{"d",  " \t:{});", " \t", 1,7, 2,1 }, 
{ "td",  " \t{};:" , " {\t", 2,6, 3,2 },
{ "s",  " \t=:([+-*/%|&><,", " \t(", 1,16, 3,1 },
{"t",  " \t=:()[|&,;/*" ,   "/,; \t&!-|)]", 1,13, 11 ,1},
{"ps",  "{; \t:", " \t:", 2,5, 3, 4 },
{"ie",  " \t;", " \t" , 2, 3,2,2 },
{"t",  " \t;", " \t" , 1, 3,2, 1 },
{"napt",  ";{ \t", " \t<" , 4, 4,3, 6 },
{"vnfhic_",  " \t:{};", " \t", 7,6,2,9 },
{"o",  " \t:{});", "!=&<>| \t", 1, 7, 8,1},
{"ra",  " ;,:({<\t", " \t", 2, 8, 2,2 },
{"mnise", " \t\n", " \t\n", 5, 3, 3, 7 },
{"cdreqa", " \t\n", " \t\n", 6, 3, 3, 11 },
{"iwsr", " \t\n", " \t\n.", 4, 3,4,4 }
};

const char **CType[StyleCount]={
	ctype0,	&ctype1,
	ctype2,	&ctype3,  &ctype4, &ctype5, &ctype6,
	ctype7, ctype8,
	ctype9, ctype10, ctype11,
	&ctype12, &ctype13, ctype14,
	&ctype15,&ctype16,ctype17,
	ctype18,&ctype19,ctype20,
	ctype21, &ctype22, ctype23,
	Tfsp0, Tfsp1, Tfsp2
}; // CType take relation of freeStyles, so don't change them.
