/*
  林江华编写，2010-3
  林江华保留此文件的版权  09-2010
  Free under LGPL
*/

#ifndef	help_widget
#define	help_widget

#include <qmainwindow.h>
#include "pluzone.h"
#include "statuspanel.h"

class QTextBrowser;
class QToolBar;
class ActMenu;
class Filesan;

extern const char slot_proedit[],
	helpwdg[];

class CustEvents : public QCustomEvent
{
public:
CustEvents(int t);
};

class HelpWdg : public QMainWindow
{
moc_Object
public:
HelpWdg(Filesan *, int tag);  // tag=0 : num;   1 : brows htm
void initForBrows(const char *fn);
void initForNumb(int numb);
void fsplusBrows(int sw);
void setNumb(int num){ _numb=num; }
int getNumb() const;
const char *getFileNam(){ return fileNam; }
QTextBrowser *getBrowser() const;

void showMessage(const char *msg);
// const int tag; // 0 is numb, 1 is brow-html

protected:
// virtual void resizeEvent( QResizeEvent * e );
bool event( QEvent *e);

private:
QTextBrowser   *brow;
int _numb,  _codec, Msg,
	tms, tmId;
QToolBar *bar;
StatusPanel *sbar;
void keysFunc(int k, int st);
const char *fileNam;
void setTitle(const QString &fn);
};

inline int HelpWdg::getNumb() const
{
return _numb;
}

inline QTextBrowser *HelpWdg::getBrowser() const
{
return brow;
}

extern QPtrList <HelpWdg> helpList;
extern HelpWdg *isActive(int numb);
extern bool browsHtml(QWidget *p, const char *fn, bool mult);
extern void fsplusLink( QWidget *par, int numb, int Msg );
extern bool fastBrows(QWidget *wdg, const char *prg, const char **fn);
extern void ExecProg(QWidget *, FastBlock *prog, FastBlock *pms);
extern void showTop(QWidget *);

extern void showLog(Filesan *fs, QStringList &msgList, int num, const char *cap);

extern FastBlock selAsSrc;

#endif
