/*
	Write by xempo 7-2014
	Free under LGPL
*/

#ifndef  List_Setting
#define  List_Setting

#include <qlabel.h>
#include <qmetaobject.h>
#include <private/qucomextra_p.h>
#include "settingwidget.h"
#include "listcontent.h"
#include "tabwdg.h"

#define  colOptCnt  7

typedef struct _lnkNode {
int num;
bool mdf;
}LnkNode;

class TWprg : protected TabWdg
{
public :
TWprg(QWidget *p, int idx);
virtual void closing();
};

class GenSetting : protected SettingWidget
{
 moc_Object

public :
GenSetting(QWidget *par);
~GenSetting();
void getParams(int * pms){ _Params=pms; }
virtual void execu(const int w, const int h, const int id);

private :
LVItem *subNodeCreat(LVItem *it, LVItem *after, const char *txt, const QPixmap *pix, const QPixmap *pix2, MAU *mau);
ListContent *optList, *lnkList;
QComboBox *settingCombo;
TWprg *tab3;
QCheckBox *peBak, *delWarn, *homeUse, *copyLog, *moreShow; // *onlyFile,
QLabel *settingLab;
QPushButton *upBtn, *downBtn, *__Btn[3];
int *_Params;

LnkNode *nodItems;
int nodCnt, nodPre;
LnkNode *tash;
int tashCnt, tashPre;
QTextCodec *utf8code;
};

extern GenSetting *genSetWdg;

#endif
